/* 
	Copyright Miloslav Semler & Monokrystaly, s.r.o
	This software is provided as-is without any warranty.
*/
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

HANDLE serial_open(const char *name){
	HANDLE hsio;
	DCB attrs = {0};
	COMMTIMEOUTS timeouts = {0};

	hsio = CreateFile(name, GENERIC_READ|GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if(hsio == INVALID_HANDLE_VALUE){
		return hsio;
	}
	attrs.DCBlength = sizeof(attrs);

	if(!GetCommState(hsio, &attrs)){
		return INVALID_HANDLE_VALUE;
	}
	
	attrs.BaudRate = CBR_9600;
	attrs.StopBits = ONESTOPBIT;
	attrs.ByteSize = 8;
	attrs.Parity = NOPARITY;
	
	if(!SetCommState(hsio, &attrs)){
		return INVALID_HANDLE_VALUE;
	}
	
	timeouts.ReadIntervalTimeout = 200;
	timeouts.ReadTotalTimeoutConstant = 500;
	timeouts.ReadTotalTimeoutMultiplier = 1;
	timeouts.WriteTotalTimeoutConstant = 100;
	timeouts.WriteTotalTimeoutMultiplier = 3;

	if(!SetCommTimeouts(hsio, &timeouts)){
		return INVALID_HANDLE_VALUE;
	}
	return hsio;

}

int do_command(char *reply_buff, size_t reply_buff_sz, const char *cmd, HANDLE hsio){
	int cycles = 0;
	DWORD bytes, cnt =0;
	if(!WriteFile(hsio, cmd, strlen(cmd), &bytes, NULL)){
		reply_buff[0] = 0;
		return -1;
	}
	while(cnt < (reply_buff_sz -1) || cycles > 5){
		bytes = 0;
		ReadFile(hsio, reply_buff + cnt, reply_buff_sz - cnt, &bytes, NULL);
		if(bytes > 0)
			cnt += bytes;
		else
			cycles++;
		if(memchr(reply_buff, '\n', cnt) != NULL){
			reply_buff[cnt] = 0;
			return 0;
		}
	}
	reply_buff[cnt] = 0;
	return -1;
}
